<?php
/*
* Chat ws-file
* WebSocket daemon itself
* 30.07.2014 Petukhovsky
* 
* config
* 
* classes 
* 
* init()
*
*/

define( 'ABSPATH', dirname(__FILE__) . '/' );

require_once(ABSPATH."fnc/ws.fnc.php");
require_once(ABSPATH."fnc/chat.fnc.php");

require(ABSPATH."cfg/ws.cfg.php");
require_once(ABSPATH."class/websocketserver.class.php");

consolemsg("init.php try to start...");

//pid-file
//Если в PID файле хранится PID процесса и он активен, то не запускаем копию
if (getstatusfwithconsole($GLOBALS['ws']['pidfile'])) {
	consolemsg("init.php can't run another websocketserver, because already running...");
	consoleend();
	exit;//1 уже запущен
}

//system config
error_reporting(E_ALL); //Выводим все ошибки и предупреждения
set_time_limit(0);		//Время выполнения скрипта безгранично
ob_implicit_flush();	//Включаем вывод без буферизации
ignore_user_abort(true);//Выключаем зависимость от пользователя
//system config

//srdin/stdout
ini_set('error_log', $GLOBALS['ws']['wserrorslogfile']);
fclose(STDOUT);
fclose(STDERR);
fclose(STDIN);
$STDIN = fopen('/dev/null', 'r');
$STDOUT = fopen($GLOBALS['ws']['wsconsolelogfile'], 'ab');
$STDERR = fopen($GLOBALS['ws']['wsconsoleerrfile'], 'ab');
//srdin/stdout

$config = array(
	'pidfile' => $GLOBALS['ws']['pidfile'],
	'offfile' => $GLOBALS['ws']['offfile'],
	'max_connects_from_ip' => $GLOBALS['ws']['maxconnectsfromip'],
	'log' => true,
	'host' => $GLOBALS['ws']['addr'],
    'port' => $GLOBALS['ws']['port']
);

$websocketserver = new websocketserver_class($config);
$websocketserver->start();

?>